﻿Type=Class
Version=2.02
@EndOfDesignText@
'DataBase Class module
'Version .98 Beta - October 8th, 2012
'Author: Margret
'B4A Version 2.02+
Private Sub Class_Globals
	Private MyModule As Object
	Private RecordCount As Int
	Private SC As String
	Private Pointer As Int
	Private FilePath, FileName As String		
	Private FileList As List
	Private Field(2) As String
	Private FieldN(2) As String
	Private WorkArea As Int
	Private N_Of_F(10) As Int
	Private useCToast As Boolean
	Type dbFilters (FieldName As String, Comparator As String, FilterValue As String, Xor As String)
	Private Filters(4) As dbFilters
	Filters(0).Initialize
	Filters(1).Initialize
	Filters(2).Initialize
	Filters(3).Initialize
	Type DataDetails (WAFileName As String, WAFilePath As String, WAField(30) As String, WAPointer As Int, WARecordCount As Int)
	Private dbWorkArea(10) As DataDetails
	dbWorkArea(0).Initialize
	dbWorkArea(1).Initialize
	dbWorkArea(2).Initialize
	dbWorkArea(3).Initialize
	dbWorkArea(4).Initialize
	dbWorkArea(5).Initialize
	dbWorkArea(6).Initialize
	dbWorkArea(7).Initialize
	dbWorkArea(8).Initialize
	dbWorkArea(9).Initialize
End Sub
'Initializes the db object for use pass Me for the calling Activity
'
'Dim db As db
'db.Initialize(Me)
Public Sub Initialize(Module As Object)
	useCToast = False
	MyModule = Module
	FileName = ""
	WorkArea = 0
	RecordCount = -1
	Pointer = -1
	SC = Chr(255)
	FileList.Initialize
	FilePath = ""
End Sub
'Creates the DataBase structure and the Fields to be used and assigns a WorkArea # for the file.
'This command is used to define all aspects of you DataBase file, See Below:
'
'Work_Area: Pass as an Int, valid values are 0 thru 9
'File_name: The name to be given to the DataBase, Example: "myfriends.dat"
'File_Path: Path to create/store your DataBase in, Example: File.DirInternal
'Fields: This is your fields needed for each record in the file.  You only need to pass the names of the 
'fields, and must pass them as an array.  Memo fields must start with ">". Note the memo field below at the 
'End of the Field definitions.
'
'Array As String("name", "address", "city", "state", "zip", "work_phone", "work_email", ">memo")
'
'Example:
'
'db.CreateDataBase(0, "deposits.dat", File.DirInternal, Array As String("reference", "amount", "date", ">deposit_memo"))
Public Sub CreateDataBase(Work_Area As Int, File_Name As String, File_Path As String, dbFields() As String)
	Dim Fields(dbFields.Length +1) As String
	For l = 0 To Fields.Length -2
		Fields(l) = dbFields(l)
	Next
	Fields(Fields.Length -1) = "*Rec_ID"		'Added to make a Record ID Field ***
	If Work_Area < 0 OR Work_Area > 9 Then
		Msgbox("Work Area must be 0 thru 9. Please select a number in this range.", "NOTICE")
		Return
	Else
		N_Of_F(Work_Area) = Fields.Length -1 
	End If
	dbWorkArea(Work_Area).WAFileName = File_Name
	dbWorkArea(Work_Area).WAFilePath = File_Path & "/"
	For l = 0 To Fields.Length -1
		dbWorkArea(Work_Area).WAField(l) = Fields(l)
	Next
	SelectWorkArea(Work_Area)
End Sub
'Used to select which DataBase structure is active.  If you created two DataBases named "one.dat" and "two.dat",
'you can select the files as follows:
'
'Selecting 0 with activate "one.dat" and selecting 1 with activate "two.dat"
'Passed as an Int, valid values are 0 thru 9. The above example is only true if
'you select 0 as the work area for "one.dat" and 1 for "two.dat".  Any of the 10
'work areas can be selected in any order.
Public Sub SelectWorkArea(Work_Area As Int)
	If Work_Area < 0 OR Work_Area > 9 Then
		Msgbox("Work Area must be 0 thru 9. Please select a number in this range.", "WARNING")
		Return
	Else
		If Len(Trim(dbWorkArea(Work_Area).WAFileName)) < 1 Then
			Msgbox("You can not select a work area where no database structure has been defined. Please select a valid work area or create a database structure in this work area.", "WARNING")
			Return
		End If
		WorkArea = Work_Area
		Private Field(N_Of_F(Work_Area) + 1), FieldN(N_Of_F(Work_Area) + 1) As String
		For l = 0 To N_Of_F(WorkArea)
			Field(l) = ""
			FieldN(l) = dbWorkArea(WorkArea).WAField(l)
		Next
		FileName = dbWorkArea(WorkArea).WAFileName
		FilePath = dbWorkArea(WorkArea).WAFilePath
	End If
	dbwaUpdate
End Sub
'Use to Rename a file. This function does not throw an exception if it fails. You must
'test the returned value yourself.  Returns True if the file was renamed otherwise it 
'returns False.  The complete path must be passed for both parameters. See Example below:
'
'RenameFile("/mnt/sdcard/Movies/Monsters Inc.mp4", "/mnt/sdcard/Movies/Monsters Inc HQ 720p.mp4")
Public Sub RenameFile(OriginalFileName As String, NewFileName As String) As Boolean
	Dim R As Reflector
	Dim NewObj As Object
	NewObj=R.CreateObject2("java.io.File",Array As Object(NewFileName),Array As String("java.lang.String"))
	R.Target=R.CreateObject2("java.io.File",Array As Object(OriginalFileName),Array As String("java.lang.String"))
	Return R.RunMethod4("renameTo",Array As Object(NewObj),Array As String("java.io.File"))
End Sub
'Returns the filename in the current work area
Sub FileName_ As String
	Return FileName
End Sub
'Returns the path of the current work area
Sub FilePath_ As String
	Return FilePath
End Sub
'Returns the number of records for the database in the current work area
Sub Record_Count As Int
	Return RecordCount
End Sub
'Returns the record pointer (current record) for the database in the current work area
Sub Record_Pointer As Int
	Return Pointer
End Sub
'Used to set the record pointer of the database in the current work area. The range must be between
'0 and the RecordCount -1
Sub Set_Pointer(m_Pointer As Int)
	If m_Pointer > -1 AND m_Pointer < RecordCount Then
		Pointer = m_Pointer
	Else
		ToastMessageShowdb("Invalid Pointer Passed", False)
	End If	
End Sub
'Adds a record to the current DataBase in the current work area, sorts the entry based on the 
'data entered and sets the DataBase Pointer to the newly added record.
Sub AddRecord
	If SubExists(MyModule, "PutFields_" & WorkArea) Then
		CallSub(MyModule, "PutFields_" & WorkArea)
	End If
	If Empty(Field(0)) Then
		Return
	End If	
	ToastMessageShowdb("Record Added", False)
	Dim FileData As List
    FileData.Initialize
	If Exist(FilePath & FileName) Then
		FileData = File.ReadList(FilePath, FileName)
	End If
	Private AF As String : AF = ""
	For fl = 0 To N_Of_F(WorkArea) -1
		If Left(FieldN(fl),1) = ">" Then
			Field(fl) = Field(fl).Replace(CRLF, Chr(245))
		End If
		AF = AF & Field(fl) & SC 
	Next
	AF = AF & GetID & SC 	'Added to include record ID ***
	FileData.Add(AF)
	RecordCount = FileData.Size
	FileData.SortCaseInsensitive(True)
	File.WriteList(FilePath, FileName, FileData)
	FileData.Clear
	FindRecord(Trim(AF))
End Sub
'Used to find a match to SearchStr. Searches every field in each record 
'of the database and returns the first record that any Fields data matches the 
'SearchStr. The more data entered the more likely the desired record will be returned
'This search IS NOT case sensitive and returns True if a match was found
'Example:
'
'If FindRecord("Billy J. Jones") Then
Sub FindRecord(SearchStr As String) As Boolean
	If Exist(FilePath & FileName) Then
		Dim FileData As List
		SearchStr = Trim(SearchStr.ToLowerCase)
	    FileData = File.ReadList(FilePath, FileName)
		RecordCount = FileData.Size
		Dim StrToSch As String
		Dim RPF As Int
		RPF = -1
		For l = 0 To FileData.Size -1
			StrToSch = FileData.Get(l)
			StrToSch = StrToSch.ToLowerCase
			RPF = At(StrToSch, SearchStr)
			If RPF > -1 Then
				RPF = l
				Pointer = RPF
				UpdatePointers
				GetRecord
				Return True
			End If
		Next
		Return False
		Msgbox("No Match Was Found", "NOTICE")
	Else
		Return False
		Msgbox("File Not Found Or No Records", "NOTICE")
	End If
End Sub
Private Sub UpdatePointers
	dbWorkArea(WorkArea).WARecordCount = RecordCount
	dbWorkArea(WorkArea).WAPointer = Pointer
	Dim dbpointers As List
	dbpointers.Initialize
	If Exist(File.DirInternal & "/dbps.db") Then
		dbpointers=File.ReadList(File.DirInternal, "dbps.db")
	Else
		For l = 0 To 9
			dbpointers.Add(0)
		Next
	End If
	dbpointers.Set(WorkArea, dbWorkArea(WorkArea).WAPointer) 
	File.WriteList(File.DirInternal, "dbps.db", dbpointers)
	dbpointers.Clear
End Sub
'Set all pointers for all databases in all work areas back the the last known
'value.  Use in Activity_Resume to return back to known location after Activity_Pause
'or after orientation change. NOTE: These pointers are saved automatically, you do not
'need to try and save the pointers in Activity_Pause 
'
'db.ResetPointers
Sub ResetPointers
	If Exist(File.DirInternal & "/dbps.db") Then
		Dim dbpointers As List
		dbpointers=File.ReadList(File.DirInternal, "dbps.db")
		For l = 0 To 9
			dbWorkArea(l).WAPointer = dbpointers.Get(l)
		Next
		dbpointers.Clear
	End If	
	Pointer = dbWorkArea(WorkArea).WAPointer
End Sub
'Loads the record at the Pointer position into memory then
'calls back to the calling activity to the Sub GetFields_X,
'where X is the workarea number 0-9. You should have a 
'GetFields_X sub in each of your Activities that makes a
'call to this db class.  No Exception is thrown if the
'GetFields_X sub is missing. The GetFields_X sub is used
'to populate your EditText.Text fields.  This helps automate
'you code.  Example:
'
'Sub GetFields_0	'Put contents of database fields into EditText fields
'	name.Text 	 = db.GetField("name") 
'	address.Text = db.GetField("address")
'	city.Text    = db.GetField("city") 
'	state.Text   = db.GetField("state") 
'	zip.Text     = db.GetField("zip") 
'	Phone.Text   = db.GetField("phone") 
'End Sub
Sub GetRecord
	If Exist(FilePath & FileName) Then
		Dim FileData As List
	    FileData = File.ReadList(FilePath, FileName)
		RecordCount = FileData.Size
		If FileData.Size < 1 Then
			FileData.Clear
			Return
		End If
		If Pointer > -1 AND Pointer <= RecordCount -1 Then
			Dim AF As String
			AF = FileData.Get(Pointer)
			Dim af2(N_Of_F(WorkArea)) As String
			af2 = Regex.Split(SC, AF)
			For l = 0 To N_Of_F(WorkArea)
				If (af2.Length -1) > = l Then
					Field(l) = af2(l)
					If Left(FieldN(l),1) = ">" Then
						Field(l) = Field(l).Replace(Chr(245), CRLF)
					End If
				Else
					Field(l) = ""
				End If	
			Next
			FileData.Clear
			UpdatePointers
			If SubExists(MyModule, "GetFields_" & WorkArea) Then
				CallSub(MyModule, "GetFields_" & WorkArea)
			End If
		End If
	Else
		Msgbox("File Not Found Or No Records", "NOTICE")
		If SubExists(MyModule, "ClearFields_" & WorkArea) Then
			CallSub(MyModule, "ClearFields_" & WorkArea)
		End If
	End If
End Sub
'Returns the value of the database field named mfieldname
'
'EditTextAddress.Text = GetField("address")
Sub GetField(mfieldname As String) As String 
	Dim wf As Int : wf = -1
	For l = 0 To ActiveFields
		If FieldN(l).ToLowerCase = mfieldname.ToLowerCase Then
			wf = l
			Exit
		End If
	Next
	If wf < 0 OR wf > ActiveFields Then
		GetStructure3(mfieldname)
		Return ""
	End If
	Return Field(wf)
End Sub
'Writes any passed value to the database field memory variable named mfieldname.
'Does not write to disk.  See AddRecord or Update record for writing the record
'to the disk.
'
'PutField("address", "8929 West Way Circle")
'
'or
'
'PutField("address", EditTextAddress.Text)
Sub PutField(mfieldname As String, varvalue As String)
	Dim wf As Int : wf = -1
	For l = 0 To ActiveFields
		If FieldN(l).ToLowerCase = mfieldname.ToLowerCase Then
			wf = l
			Exit
		End If
	Next
	If wf < 0 OR wf > ActiveFields Then
		GetStructure3(mfieldname)
		Return
	End If
	Field(wf) = varvalue
End Sub
'Returns a new date from the date passed plus or minus HowManyDays. Pass mDate as String, 
'HowManyDays As Int. HowManyDays can be positive or negitive numbers.
'
'DateDue = DateNew("02/04/2012", 90)
Sub DateNew(mDate As String, HowManyDays As Int) As String
	Dim ConvertDate, NewDateDay As Long
	ConvertDate = DateTime.DateParse(mDate)
	NewDateDay = DateTime.Add(ConvertDate, 0, 0, HowManyDays)
	Return DateTime.Date(NewDateDay)
End Sub
'Returns the number of days that have passed between two dates.
'Pass the dates as a String
Sub DateNOD(CurrentDate As String, OtherDate As String) As Int
	Dim CurrDate, OthDate, MyNewDate As Long
	CurrDate = DateTime.DateParse(CurrentDate)
	OthDate = DateTime.DateParse(OtherDate)
	Return (CurrDate-OthDate)/(DateTime.TicksPerDay)
End Sub
'Returns the systems date as a String
Sub Date() As String 
	Return DateTime.Date(DateTime.Now)
End Sub
'Returns the current number of data fields in the current work area
'Returns number as Int. This object is Readonly
Sub ActiveFields As Int
	Return N_Of_F(WorkArea)
End Sub
'Displays the structure of the database in the active work area
Sub GetStructure()
	StrVar = ""
	StrVar = "Name: " & dbWorkArea(WorkArea).WAFileName & CRLF 
	StrVar = StrVar & "Path: " & dbWorkArea(WorkArea).WAFilePath & CRLF
	For l = 0 To N_Of_F(WorkArea)
		StrVar = StrVar & "Field:" & (l+1) & " - "
		StrVar = StrVar & dbWorkArea(WorkArea).WAField(l) & CRLF
	Next
	Msgbox(StrVar,"Current Active DataBase Structure:")	
End Sub
'Same as GetStructure but accepts the work area as an Int. This will display the
'structure of any database in any workarea even if it is not the active database.
Sub GetStructure2(Work_Area As Int)
	StrVar = ""
	StrVar = "Name: " & dbWorkArea(Work_Area).WAFileName & CRLF 
	StrVar = StrVar & "Path: " & dbWorkArea(Work_Area).WAFilePath & CRLF
	For l = 0 To N_Of_F(Work_Area)
		StrVar = StrVar & "Field:" & (l+1) & " - "
		StrVar = StrVar & dbWorkArea(Work_Area).WAField(l) & CRLF
	Next
	Msgbox(StrVar,"DataBase Structure Work Area: " & Work_Area)	
End Sub
Private Sub GetStructure3(mvar As String)
	StrVar = "ERROR: Field [" & mvar & "] not found..." & CRLF & CRLF
	For l = 0 To ActiveFields
		StrVar = StrVar & "Field:" & (l+1) & " - "
		StrVar = StrVar & dbWorkArea(WorkArea).WAField(l) & CRLF
	Next
	Msgbox(StrVar,"Current Active DataBase Structure:")	
End Sub
Private Sub dbwaUpdate
	If Exist(FilePath & FileName) Then
		Dim FileData As List
    	FileData = File.ReadList(FilePath, FileName)
		RecordCount = FileData.Size
		dbWorkArea(WorkArea).WARecordCount = RecordCount
		If Pointer < 0 AND RecordCount > 0 Then
			Pointer = 0
			dbWorkArea(WorkArea).WAPointer = Pointer
		Else
			If dbWorkArea(WorkArea).WAPointer > -1 AND dbWorkArea(WorkArea).WAPointer <= RecordCount -1 Then
				Pointer = dbWorkArea(WorkArea).WAPointer
			End If
		End If
		FileData.Clear
	End If
End Sub
'Use this for testing to populate the database with random data
'Accepts a number 1 to 10000 as Int. Populates the database in 
'the current workarea.
Sub GenerateRecords(Howmany)
	Dim FileData As List
    FileData.Initialize
	If Exist(FilePath & FileName) Then
		FileData = File.ReadList(FilePath, FileName)
	End If	
	Dim AF As String
	AF = "" 
	ProgressDialogShow("Generating " & Howmany & " Records, Please Wait...")
	For l = 1 To Howmany
		DoEvents
		For fl = 0 To ActiveFields -1
			AF = AF & RndChrGen(10, 2) & SC
		Next
		AF = AF & GetID & SC
		FileData.Add(AF)
		AF = ""
	Next
	RecordCount = FileData.Size
	File.WriteList(FilePath, FileName, FileData)
	ProgressDialogHide
	FileData.Clear
End Sub
'Updates the record at pointer position in the current workarea with data
'stored in the memory fields.  See db.PutFields() to place data into their
'memory location.
Sub UpdateRecord()
	If Exist(FilePath & FileName) Then
		If SubExists(MyModule, "PutFields_" & WorkArea) Then
			CallSub(MyModule, "PutFields_" & WorkArea)
		End If
		Dim FileData As List
	    FileData.Initialize
		FileData = File.ReadList(FilePath, FileName)
		If FileData.Size < 1 Then
			FileData.Clear
			Return
		End If
		Dim AF As String
		AF = ""
		For fl = 0 To ActiveFields
			If Left(FieldN(fl),1) = ">" Then
				Field(fl) = Field(fl).Replace(CRLF, Chr(245))
			End If
			AF = AF & Field(fl) & SC 
		Next
		FileData.Set(Pointer, AF)
		FileData.SortCaseInsensitive(True)
		RecordCount = FileData.Size
		File.WriteList(FilePath, FileName, FileData)
		FileData.Clear
		FindRecord(Trim(AF))
	Else
		Msgbox("File Not Found Or No Records", "NOTICE")
	End If
End Sub
'Delete the current record at Pointer position in the current work area.
'A confirmation box will be displayed, if user selects Yes, record will 
'be deleted. The next record following will become the current record.
Sub DeleteRecord
	If Exist(FilePath & FileName) Then
		Dim FileData As List
    	FileData.Initialize
		FileData = File.ReadList(FilePath, FileName)
		If FileData.Size < 1 Then
			FileData.Clear
			Msgbox("DataBase is Empty", "NOTICE")
			Return
		End If	
		If Msgbox2("Please Confirm Your Choice?", "Delete Record For: " & Field(0),"Yes", "", "No", Null) = DialogResponse.POSITIVE Then
    	Else
    		Return
    	End If
		ToastMessageShowdb("Record Deleted", False)
		FileData.RemoveAt(Pointer)
		RecordCount = FileData.Size
		File.WriteList(FilePath, FileName, FileData)
		If FileData.Size > 0 Then
			If Pointer < FileData.Size -1 Then
			Else
				Pointer = FileData.Size -1
			End If
		Else
			Msgbox("DataBase is Empty", "NOTICE")
			FileData.Clear
			RecordCount = 0
			Pointer = -1
			UpdatePointers
			Return
		End If
		FileData.Clear
		UpdatePointers
		GetRecord
	Else
		Msgbox("File Not Found Or No Records", "NOTICE")
	End If
End Sub
'Checks to see if the selected path and file exist
'Example:
'
'db.Exist("/mnt/sdcard/Documents.txt")
Public Sub Exist(PathAndFile As String) As Boolean
	If File.Exists("", PathAndFile) Then Return True Else Return False
End Sub
'Find an Exact match to the SearchStr passed. Not case sensitive.
Sub FindExact(SearchStr As String)
	If Exist(FilePath & FileName) Then
		Dim FileData As List
		SearchStr = Trim(SearchStr.ToLowerCase)
	    FileData = File.ReadList(FilePath, FileName)
		RecordCount = FileData.Size
		Dim StrToSch As String
		Dim RPF As Int
		RPF = -1
		For l = 0 To FileData.Size -1
			StrToSch = FileData.Get(l)
			StrToSch = Left(StrToSch, At(StrToSch, SC))
			StrToSch = StrToSch.ToLowerCase
			If StrToSch = SearchStr Then
				RPF = 1
			Else
				RPF = -1
			End If
			If RPF > -1 Then
				RPF = l
				Pointer = RPF
				UpdatePointers
				GetRecord
				Return
			End If
		Next
		ToastMessageShowdb("No Match Was Found", False)
	Else
		Msgbox("File Not Found Or No Records", "NOTICE")
	End If
End Sub
'Moves Pointer to the first record in the DataBase and reads the record into memory
Sub FirstRecord
	If Exist(FilePath & FileName) Then
		Dim FileData As List
    	FileData = File.ReadList(FilePath, FileName)
		RecordCount = FileData.Size
		If FileData.Size > 0 Then
			Pointer = 0
			UpdatePointers
			GetRecord
		End If
	Else
		Msgbox("File Not Found Or No Records", "NOTICE")
	End If
End Sub
'Moves Pointer to the last record in the DataBase and reads the record into memory
Sub LastRecord
	If Exist(FilePath & FileName) Then
		Dim FileData As List
    	FileData = File.ReadList(FilePath, FileName)
		RecordCount = FileData.Size
		If FileData.Size > 0 Then
			Pointer = FileData.Size -1
			UpdatePointers
			GetRecord
		End If
	Else
		Msgbox("File Not Found Or No Records", "NOTICE")
	End If
End Sub
'Moves Pointer to the previous record in the DataBase and reads the record into memory
'BOF is handled and will show a Toast Message if BOF is reached
Sub PreviousRecord
	If Exist(FilePath & FileName) Then
		Dim FileData As List
    	FileData = File.ReadList(FilePath, FileName)
		RecordCount = FileData.Size
		If Pointer > 0 Then
			Pointer = Pointer -1
			UpdatePointers
			GetRecord
		Else
			ToastMessageShowdb("No More Records, Beginning Of File", False)
		End If
	Else
		Msgbox("File Not Found Or No Records", "NOTICE")
	End If
End Sub
'Moves Pointer to the next record in the DataBase and reads the record into memory
'EOF is handled and will show a Toast Message if EOF is reached
Sub NextRecord
	If Exist(FilePath & FileName) Then
		Dim FileData As List
    	FileData = File.ReadList(FilePath, FileName)
		RecordCount = FileData.Size
		If Pointer < FileData.Size -1 Then
			Pointer = Pointer +1
			UpdatePointers
			GetRecord
		Else
			ToastMessageShowdb("No More Records, End Of File", False)
		End If
	Else
		Msgbox("File Not Found Or No Records", "NOTICE")
	End If
End Sub
Private Sub ValidDate(ChkDate) As Boolean
	Private dcf As Int
	Private GoodDate As String
	dcf = 0
	Try
    	GoodDate = DateTime.DateParse(ChkDate)
	Catch
    	GoodDate = ""
		dcf = 1
	End Try
	If dcf = 0 Then
		Return True
	Else
		Return False
	End If	
End Sub
Private Sub Left(Text As String, Length As Long)As String 
	If Length>Text.Length Then Length=Text.Length 
	Return Text.SubString2(0, Length)
End Sub
Private Sub Right(Text As String, Length As Long) As String
	If Length>Text.Length Then Length=Text.Length 
	Return Text.SubString(Text.Length-Length)
End Sub
Private Sub Mid(Text As String, Start As Int, Length As Int) As String 
	Return Text.SubString2(Start-1,Start+Length-1)
End Sub
Private Sub At(Text As String, SearchFor As String) As Int
	Return Text.IndexOf(SearchFor)
End Sub
Private Sub Stuff(MyString As String, IncertChr As String, IncertStr As String) As String  
	Return Left(MyString,At(MyString, IncertStr)) & IncertChr & Right(MyString, (Len(MyString)-At(MyString, IncertStr))-Len(IncertStr))
End Sub
Private Sub Trim(Text As String) As String
	Return Text.Trim
End Sub
Private Sub Len(Text As String) As Int
	Return Text.Length
End Sub
Private Sub Ltrim(Text As String) As String
	Do While Left(Text, 1) =" "
		Text = Right(Text, Len(Text)-1)
	Loop
	Return Text
End Sub
Private Sub Rtrim(Text As String) As String
	Do While Right(Text, 1) =" "
		Text = Left(Text, Len(Text)-1)
	Loop
	Return Text
End Sub
Private Sub Val(Text As String) As Long
	Do While IsNumber(Right(Text,1))=False Then
		If Len(Text) >0 Then
			Text = Left(Text, Len(Text)-1)
		Else
			Exit
		End If	
	Loop
	If Len(Text) > 0 Then 
		Return Text + 0
	Else
		Return 0
	End If	
End Sub
'Checks to see if the Text passed is empty, or has a length of 0
Public Sub Empty(Text As String) As Boolean
	Text = Trim(Text)
	If Text.Length < 1 Then
		Return True
	Else
		Return False
	End If	
End Sub
Private Sub iif(Text As String, Text1 As String, Text2 As String) As String
	If Text = True Then Return Text1 Else Return Text2
End Sub
Private Sub RndChrGen(Howmany As Int, CT As Int) As String
	Dim A As String
	Dim L, U, ha As Int
	A=""
	If CT = 0 Then
		L = 65 : U = 122
	Else If CT=1 Then
		L = 65 : U = 90
	Else
		L = 97 : U = 122
	End If
	For x = 1 To Howmany				
		Do While Len(A) < Howmany	
			ha = Rnd(L, U)
			If ha > = 91 AND ha < = 96 Then 
			Else
				A = A & Chr(ha)
			End If
		Loop
	Next
	Return A
End Sub
Private Sub Space(HM As Int) As String
	Dim RS As String : RS = ""
	Do While Len(RS) < HM
		RS = RS & " "
	Loop
	Return RS
End Sub
'Returns True if the CurrentDate and the CompareToDate are within X number of days(DateRange)
'of each other. Otherwise False will be returned.
Sub SearchDate(CurrentDate As String, CompareToDate As String, DateRange As Int) As Boolean
	Dim DayOfYearCompareDate, DayOfYearCurrentDate As Long
	If ValidDate(CurrentDate) AND ValidDate(CompareToDate) Then
	Else
		Return False
	End If
	DayOfYearCompareDate = DateTime.GetDayOfYear(DateTime.DateParse(CompareToDate))
	DayOfYearCurrentDate = DateTime.GetDayOfYear(DateTime.DateParse(CurrentDate))
	If DayOfYearCompareDate >= DayOfYearCurrentDate AND DayOfYearCompareDate <= (DayOfYearCurrentDate + DateRange) Then
		Return True
	Else
		Return False
	End If
End Sub
Private Sub Stuff2(MyString As String, InsertChr As String, Where As Int) As String  
	Return Left(MyString, Where) & InsertChr & Right(MyString, (Len(MyString) - Where))
End Sub
Private Sub ToastMessageShowdb(dbMessage As String, LongWait As Boolean)
	If useCToast Then
		If SubExists(MyModule, "dbToastMessage") Then
			If LongWait Then
				CallSub3(MyModule, "dbToastMessage", dbMessage, 5)
			Else
				CallSub3(MyModule, "dbToastMessage", dbMessage, 3)
			End If
		End If
	Else
		ToastMessageShow(dbMessage, LongWait)
	End If
End Sub
Private Sub GetID As Int
	If File.Exists(File.DirInternal, "id.db") = False Then
		File.WriteString(File.DirInternal, "id.db", "0")
	End If
	Dim m_ID As Int
	m_ID = File.ReadString(File.DirInternal, "id.db") + 1
	File.WriteString(File.DirInternal, "id.db", m_ID)
	Return m_ID
End Sub
'Returns a list with your selected fields in an InputList.
'If user selects an entry, it reads the record in to memory
'and returns the number of the record selected and sets the
'record pointer to this record.
'
'db.ListRecords("Contact Listing", Array As String("name", "address", "phone", "zip")
Sub ListRecords(ListTitle As String, dbFields() As String)
	If Exist(FilePath & FileName) Then
		Dim FileData As List : Dim fl As Int
    	FileData = File.ReadList(FilePath, FileName)
		RecordCount = FileData.Size
		Dim showlist(FileData.Size) As String
		For l = 0 To FileData.Size -1	'# of record in DataBase
			Dim af2() As String
			af2 = Regex.Split(SC, FileData.Get(l))
			For al = 0 To dbFields.Length -1	'Fields passed in to gather
				For al2 = 0 To af2.Length -1	'# of fields in each record
					If dbFields(al).ToLowerCase = FieldN(al2).ToLowerCase Then
						showlist(l) = showlist(l) & Trim(af2(al2)) & " - "
					End If
				Next
			Next
			If showlist(l).Length > 2 Then
				showlist(l) = Left(showlist(l), (Len(showlist(l)) -3))
			End If
		Next
		Dim ANS As Int
		ANS = InputList(showlist, ListTitle, 0)
		If ANS = DialogResponse.CANCEL Then
			ToastMessageShowdb("User Canceled", False)
			Return
		End If
		FileData.Clear
		Pointer = ANS
		GetRecord
	End If	
End Sub
'Returns a list with the select fields from the database. Pass the field names as
'a string.  Returns the listing as a List variable. If no Filter is needed pass 
'"". If a filter is needed pass Text to match:
'
'db.PullList(Array As String("name", "zip", "phone", "37421"))
Sub PullList(dbFields() As String, Filter As String) As List
	If Exist(FilePath & FileName) Then
		Dim FileData As List : Dim fl As Int : Dim sl As String
    	FileData = File.ReadList(FilePath, FileName)
		RecordCount = FileData.Size
		Dim showlist As List
		showlist.Initialize
		For l = 0 To FileData.Size -1	'# of record in DataBase
			Dim af2() As String
			af2 = Regex.Split(SC, FileData.Get(l))
			sl = ""
			For al = 0 To dbFields.Length -1	'Fields passed in to gather
				For al2 = 0 To af2.Length -1	'# of fields in each record
					If dbFields(al).ToLowerCase = FieldN(al2).ToLowerCase Then
						sl = sl & Trim(af2(al2)) & " - "
					End If
				Next
			Next
			If Empty(Filter) = False Then
				If At(sl.ToLowerCase, Filter.ToLowerCase) < 0 Then
					sl = ""
				End If
			End If
			If sl.Length > 2 Then
				sl = Left(sl, (Len(sl) -3))
				showlist.Add(sl)
			End If
		Next
		Return showlist
	End If	
End Sub
Sub CopyDirectory(FromDirPath As String, FromFolderName As String, ToDirPath As String, ToFolderName As String, IncludeSubFolders As Boolean)
	Dim FilesList As List
	If File.Exists(ToDirPath, ToFolderName) = False AND Empty(ToFolderName) = False Then
		File.MakeDir(ToDirPath, ToFolderName)
	End If	
	FilesList.Initialize
	Dim FilesName As String
	FilesList = File.ListFiles(FromDirPath & iif(Empty(FromFolderName) = False, "/", "") & FromFolderName)
	If FilesList.Size > 0 Then
		For l = 0 To FilesList.Size-1
			FilesName = FilesList.Get(l)
			If File.IsDirectory(FromDirPath & iif(Len(Trim(FromFolderName))>0, "/", "") & FromFolderName, FilesName) Then
				If IncludeSubFolders Then
					CopyDirectory(FromDirPath & iif(Len(Trim(FromFolderName))>0, "/", "") & FromFolderName, FilesName, ToDirPath & iif(Len(Trim(ToFolderName))>0, "/", "") & ToFolderName, FilesName, IncludeSubFolders)
				End If
			Else
				File.Copy(FromDirPath & iif(Len(Trim(FromFolderName))>0, "/", "") & FromFolderName, FilesName, ToDirPath & iif(Len(Trim(ToFolderName))>0, "/", "") & ToFolderName, FilesName)
			End If
		Next
	End If
End Sub